; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_FTD.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
D1:   ; DWord
.byte     4
D2:   ; DWord
.byte     4
C1:   ; Char
.byte     1
C2:   ; Char
.byte     1
W1:   ; Word
.byte     2
W2:   ; Word
.byte     2
Z1:   ; Byte
.byte     1
Z2:   ; Byte
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; PROCEDURE - Anfang (P1)
P1:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000000)
        LDI        R16, 0x00
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (D3)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Ausdruck / Zahlenwert (00000005)
        LDI        R16, 0x05
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; FOR TO DO - Laden des lokal DWord-Zaehlwertes
        MOV        R20, R0
        MOV        R21, R1
        MOV        R22, R2
        MOV        R23, R3
 
; FOR TO DO - Vergleichswert DWord in Stack
        PUSH       R16
        PUSH       R17
        PUSH       R18
        PUSH       R19
 
; FOR TO DO - Marke_Start
M_FTD_01:
 
; FOR TO DO - DWord-Vergleichsteil (TO)
        POP        R19
        POP        R18
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        PUSH       R18
        PUSH       R19
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BRCC       M_FTD_02
        RJMP       M_FTD_03
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_02:
 
; FOR TO DO - (lokal)DWord-INC-Zaehler
        MOV        R20, R0
        MOV        R21, R1
        MOV        R22, R2
        MOV        R23, R3
        CLR        R24
        SEC
        ADC        R20, R24
        ADC        R21, R24
        ADC        R22, R24
        ADC        R23, R24
        MOV        R0, R20
        MOV        R1, R21
        MOV        R2, R22
        MOV        R3, R23
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_01
 
; FOR TO DO - Ende
M_FTD_03:
 
; FOR TO DO - Vergleichswert (DWord) vom Stack holen
        POP        R19
        POP        R18
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (P1)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (Z1)
        STS        Z1, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; FOR TO DO - Laden des Byte-Zaehlwertes
        LDS        R17, Z1
 
; FOR TO DO - Vergleichswert Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_04:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_05
        RJMP       M_FTD_06
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_05:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (Z2)
        STS        Z2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x16)
        LDI        R16, 0x16
 
; FOR TO DO - Laden des Byte-Zaehlwertes
        LDS        R17, Z2
 
; FOR TO DO - Vergleichswert Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_07:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_08
        RJMP       M_FTD_09
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_08:
 
; FOR TO DO - (global)Byte-INC-Zaehler
        LDS        R17, Z2
        INC        R17
        STS        Z2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_07
 
; FOR TO DO - Ende
M_FTD_09:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; FOR TO DO - (global)Byte-INC-Zaehler
        LDS        R17, Z1
        INC        R17
        STS        Z1, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_04
 
; FOR TO DO - Ende
M_FTD_06:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0000007B)
        LDI        R16, 0x7B
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (D1)
        STS        D1, R16
        STS        D1+1, R17
        STS        D1+2, R18
        STS        D1+3, R19
 
; FOR TO DO - Ausdruck / Zahlenwert (000001C8)
        LDI        R16, 0xC8
        LDI        R17, 0x01
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; FOR TO DO - Laden des DWord-Zaehlwertes
        LDS        R20, D1
        LDS        R21, D1+1
        LDS        R22, D1+2
        LDS        R23, D1+3
 
; FOR TO DO - Vergleichswert DWord in Stack
        PUSH       R16
        PUSH       R17
        PUSH       R18
        PUSH       R19
 
; FOR TO DO - Marke_Start
M_FTD_010:
 
; FOR TO DO - DWord-Vergleichsteil (TO)
        POP        R19
        POP        R18
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        PUSH       R18
        PUSH       R19
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BRCC       M_FTD_011
        RJMP       M_FTD_012
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_011:
 
; FOR TO DO - (global)DWord-INC-Zaehler
        LDS        R20, D1
        LDS        R21, D1+1
        LDS        R22, D1+2
        LDS        R23, D1+3
        CLR        R24
        SEC
        ADC        R20, R24
        ADC        R21, R24
        ADC        R22, R24
        ADC        R23, R24
        STS        D1, R20
        STS        D1+1, R21
        STS        D1+2, R22
        STS        D1+3, R23
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_010
 
; FOR TO DO - Ende
M_FTD_012:
 
; FOR TO DO - Vergleichswert (DWord) vom Stack holen
        POP        R19
        POP        R18
        POP        R17
        POP        R16
 
; Aufruf PROCEDURE (P1)
        CALL       P1
 
; *** Namen-Liste ***
;
; D1 (V) DWORD
; D2 (V) DWORD
; C1 (V) CHAR
; C2 (V) CHAR
; W1 (V) WORD
; W2 (V) WORD
; Z1 (V) BYTE
; Z2 (V) BYTE
; P1 (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE P1 (D3 : DWORD);
 
