PROGRAM test_wait;

DEVICE = mega8;


{$I mega8_Register.INC}



PROCEDURE wait_ms(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to 720 do // 45 * MHz
    endfor;
  endfor;
END wait_ms;


procedure InitPorts;
begin
  DDRD:=  %11100000;
end InitPorts;


BEGIN

{
PD0 - RXD
PD1 - TXD
PD2 - Taster1
PD3 - Taster2
PD4 - Taster3
PD5 - LED1
PD6 - LED2
PD7 - Summer


PC4 - SDA
PC5 - SCL
}

  InitPorts;

  PORTD:=%00000000;

  LOOP

    PORTD:=%00100000;
    wait_ms(500);

    PORTD:=%01000000;
    wait_ms(500);

  ENDLOOP;

END test_wait.
