; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_WHILE_DO.PAS
 
.nolist
.INCLUDE "m1284Pdef.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
KURSOR_SCHLEIFE:   ; DWord
.byte     4
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000005)
        LDI        R16, 0x05
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
        STS        KURSOR_SCHLEIFE+2, R18
        STS        KURSOR_SCHLEIFE+3, R19
 
; WHILE DO ...
M_WHILE_01:
 
; WHILE - Ausdruck erster Faktor / DWord-VAR (KURSOR_SCHLEIFE)
        LDS        R16, KURSOR_SCHLEIFE
        LDS        R17, KURSOR_SCHLEIFE+1
        LDS        R18, KURSOR_SCHLEIFE+2
        LDS        R19, KURSOR_SCHLEIFE+3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (00000064)
        LDI        R20, 0x64
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator <
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BRCS       M_VERGL_04
        CLR        R16
        RJMP       M_VERGL_05
M_VERGL_04:
        SER        R16
M_VERGL_05:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_02
        RJMP       M_WHILE_03
M_WHILE_02:
 
; Zuweisung Quelle - Ausdruck erster Faktor / DWord-VAR (KURSOR_SCHLEIFE)
        LDS        R16, KURSOR_SCHLEIFE
        LDS        R17, KURSOR_SCHLEIFE+1
        LDS        R18, KURSOR_SCHLEIFE+2
        LDS        R19, KURSOR_SCHLEIFE+3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0000000A)
        LDI        R20, 0x0A
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator +
        ADD        R16, R20
        ADC        R17, R21
        ADC        R18, R22
        ADC        R19, R23
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
        STS        KURSOR_SCHLEIFE+2, R18
        STS        KURSOR_SCHLEIFE+3, R19
 
; WHILE DO ...
        RJMP       M_WHILE_01
M_WHILE_03:
 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UDR1 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR1H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UBRR1L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; UCSR1A (V) BYTECONVAR
; UCSR1B (V) BYTECONVAR
; UCSR1C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; OCR3BL (V) BYTECONVAR
; OCR3BH (V) BYTECONVAR
; OCR3AH (V) BYTECONVAR
; OCR3AL (V) BYTECONVAR
; ICR3L (V) BYTECONVAR
; ICR3H (V) BYTECONVAR
; TCNT3L (V) BYTECONVAR
; TCNT3H (V) BYTECONVAR
; TCCR3C (V) BYTECONVAR
; TCCR3B (V) BYTECONVAR
; TCCR3A (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; TIMSK3 (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; PRR1 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR3 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; UBRR0 (V) WORDCONVAR
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; KURSOR_SCHLEIFE (V) DWORD
 
