; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_ARRAY.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
B1:   ; Byte
.byte     1
W1:   ; Word
.byte     2
X1:   ; Word
.byte     2
 
A2:
.byte     62
A3:
.byte     31
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0007)
        LDI        R16, LOW(0x0007)
        LDI        R17, HIGH(0x0007)
 
; Zuweisung Ziel /  VAR (X1)
        STS        X1, R16
        STS        X1+1, R17
 
; ARRAY - Ausdruck erster Faktor / Word-VAR (X1)
        LDS        R16, X1
        LDS        R17, X1+1
 
; ARRAY - Ausdruck zweiter Faktor / Zahlenwert (0x0008)
        LDI        R18, LOW(0x0008)
        LDI        R19, HIGH(0x0008)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (A2)
        LDI        ZL, LOW(A2)
        LDI        ZH, HIGH(A2)
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z+
        LD         R17, Z
 
; Zuweisung Ziel /  VAR (W1)
        STS        W1, R16
        STS        W1+1, R17
 
; VAR ARRAY POSITION - Ausdruck erster Faktor / Word-VAR (X1)
        LDS        R16, X1
        LDS        R17, X1+1
 
; VAR ARRAY POSITION - Ausdruck zweiter Faktor / Zahlenwert (0x007B)
        LDI        R18, LOW(0x007B)
        LDI        R19, HIGH(0x007B)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; VAR ARRAY Ziel Zeiger berechnen (A2)
        LDI        ZL, LOW(A2)
        LDI        ZH, HIGH(A2)
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Word-VAR (W1)
        LDS        R16, W1
        LDS        R17, W1+1
 
; Zuweisung Ziel /  VAR ARRAY (A2)
        POP        ZH
        POP        ZL
        ST         Z+, R16
        ST         Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x1234)
        LDI        R16, LOW(0x1234)
        LDI        R17, HIGH(0x1234)
 
; Zuweisung Ziel /  VAR (W1)
        STS        W1, R16
        STS        W1+1, R17
 
; VAR ARRAY POSITION - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; VAR ARRAY Ziel Zeiger berechnen (A2)
        LDI        ZL, LOW(A2)
        LDI        ZH, HIGH(A2)
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Word-VAR (W1)
        LDS        R16, W1
        LDS        R17, W1+1
 
; Zuweisung Ziel /  VAR ARRAY (A2)
        POP        ZH
        POP        ZL
        ST         Z+, R16
        ST         Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x34)
        LDI        R16, 0x34
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; VAR ARRAY POSITION - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; VAR ARRAY Ziel Zeiger berechnen (A3)
        LDI        ZL, LOW(A3)
        LDI        ZH, HIGH(A3)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (B1)
        LDS        R16, B1
 
; Zuweisung Ziel /  VAR ARRAY (A3)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; *** Namen-Liste ***
;
; B1 (V) BYTE
; W1 (V) WORD
; X1 (V) WORD
; A2 (Y) WORD
; A3 (Y) BYTE
 
