; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_ARRAY.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        WERT_ENDE  =  0x001E ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
A2:
.byte     62
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; VAR ARRAY POSITION - Ausdruck / Zahlenwert (0x000F)
        LDI        R16, LOW(0x000F)
        LDI        R17, HIGH(0x000F)
 
; VAR ARRAY Ziel Zeiger berechnen (A2)
        LDI        ZL, LOW(A2)
        LDI        ZH, HIGH(A2)
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0003)
        LDI        R16, LOW(0x0003)
        LDI        R17, HIGH(0x0003)
 
; Zuweisung Ziel /  VAR ARRAY (A2)
        POP        ZH
        POP        ZL
        ST         Z+, R16
        ST         Z, R17
 
; *** Namen-Liste ***
;
; WERT_ENDE (C) WORD Wert=0x001E
; A2 (Y) WORD
 
