; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: DWORD.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        DW1  =  0x98765431 ; DWORD
 
; *** Variablentabelle ***
 
.dseg
 
B1:   ; Byte
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(0,DW1)
        LDI        R16, 0x31
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; *** Namen-Liste ***
;
; DW1 (C) DWORD Wert=98765431
; B1 (V) BYTE
 
