; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: DWORD.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        B1  =  0x14 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
DW1:   ; DWord
.byte     4
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / ByteToDW(B1)
        LDI        R16, 0x14
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (DW1)
        STS        DW1, R16
        STS        DW1+1, R17
        STS        DW1+2, R18
        STS        DW1+3, R19
 
; *** Namen-Liste ***
;
; B1 (C) BYTE Wert=0x14
; DW1 (V) DWORD
 
