; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_CHAR.PAS
 
.nolist
.INCLUDE "m328Pdef.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
CH:   ; Char
.byte     1
CURSCAN_WORD:   ; Word
.byte     2
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; ARRAY - Ausdruck / Word-VAR (CURSCAN_WORD)
        LDS        R16, CURSCAN_WORD
        LDS        R17, CURSCAN_WORD+1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_NORMAL)
        LDI        ZL, LOW(2*CODETAB_NORMAL)
        LDI        ZH, HIGH(2*CODETAB_NORMAL)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; *** Namen-Liste ***
;
; CODETAB_NORMAL (A) 
; CH (V) CHAR
; CURSCAN_WORD (V) WORD
 
; *** Konstanten-ARRAYs ***
;
 
CODETAB_NORMAL:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    '^',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'q'
.db    '1',0x00
.db    0x00,0x00
.db    'y','s'
.db    'a','w'
.db    '2',0x00
.db    0x00,'c'
.db    'x','d'
.db    'e','4'
.db    '3',0x00
.db    0x00,' '
.db    'v','f'
.db    't','r'
.db    '5',0x00
.db    0x00,'n'
.db    'b','h'
.db    'g','z'
.db    '6',0x00
.db    0x00,0x00
.db    'm','j'
.db    'u','7'
.db    '8',0x00
.db    0x00,','
.db    'k','i'
.db    'o','0'
.db    '9',0x00
.db    0x00,'.'
.db    '-','l'
.db    'o','p'
.db    0x5C,0x00
.db    0x00,0x00
.db    'a',0x00
.db    'u',0x27
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'+'
.db    0x00,'#'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
