PROGRAM MEGA;

DEVICE = mega2560;

{$I mega2560_Register.INC}



CONST

  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 16000;

  // bei 16,000 MHz ->
  UBRR_VAL : Byte = 5;




{$I ICON19.INC}

{$I SinTab.INC}

VAR

  LED_GELB[PortB, 7] : bit;
  ein_Word : Word;

  CARR : Adress;
  b1 : Byte;



{$I SYSTEM.INC}



procedure InitPorts;
begin
  DDRB:=  %11111111;
  DDRC:=  %11111111;
  DDRD:=  %11111100;
end InitPorts;


BEGIN

  CARR:=ArrToAdress(SINTAB);
  b1:=ReadAdrArray(CARR,2);



  InitPorts;



  loop


    SetBit(LED_GELB);

    wait_ms(500);

    ClearBit(LED_GELB);

    wait_ms(500);


  endloop;



END MEGA.
