; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_ARRAY.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
D1:   ; DWord
.byte     4
W1:   ; Word
.byte     2
 
A2:
.byte     124
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (12345678)
        LDI        R16, 0x78
        LDI        R17, 0x56
        LDI        R18, 0x34
        LDI        R19, 0x12
 
; Zuweisung Ziel /  VAR (D1)
        STS        D1, R16
        STS        D1+1, R17
        STS        D1+2, R18
        STS        D1+3, R19
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; Zuweisung Ziel /  VAR (W1)
        STS        W1, R16
        STS        W1+1, R17
 
; VAR ARRAY POSITION - Ausdruck erster Faktor / Word-VAR (W1)
        LDS        R16, W1
        LDS        R17, W1+1
 
; VAR ARRAY POSITION - Ausdruck zweiter Faktor / Zahlenwert (0x0003)
        LDI        R18, LOW(0x0003)
        LDI        R19, HIGH(0x0003)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; VAR ARRAY Ziel Zeiger berechnen (A2)
        LDI        ZL, LOW(A2)
        LDI        ZH, HIGH(A2)
        LSL        R16
        ROL        R17
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / DWord-VAR (D1)
        LDS        R16, D1
        LDS        R17, D1+1
        LDS        R18, D1+2
        LDS        R19, D1+3
 
; Zuweisung Ziel /  VAR ARRAY (A2)
        POP        ZH
        POP        ZL
        ST         Z+, R16
        ST         Z+, R17
        ST         Z+, R18
        ST         Z, R19
 
; *** Namen-Liste ***
;
; D1 (V) DWORD
; A2 (Y) DWORD
; W1 (V) WORD
 
